<?php
/*
Plugin Name: i18n DeepL Page Translation
Description: Clones pages to a different language slug, while translating their content using DeepL
Version: 1.0
*/
 
# get correct id for plugin
$plugin_id = basename(__FILE__, ".php");
$datasettingspath = GSDATAOTHERPATH . $plugin_id . '_settings.xml';


i18n_merge($plugin_id) || i18n_merge($plugin_id,'en_US');

$datafolder = GSDATAOTHERPATH . '/' . $plugin_id . '/';
 
register_plugin(
	$plugin_id, //Plugin id
	'i18n DeepL Page Translation', 	//Plugin name
	'1.0', 		//Plugin version
	'Astrid Hanssen',  //Plugin author
	'http://astrid-hanssen.de/', //author website
	'Translates page content and other fields using the DeepL API', //Plugin description
	'plugins', //pages type - on which admin tab to display
	'do_dispatch'  //main function (administration)
);
 
if (substr(parse_url($_SERVER['PHP_SELF'],PHP_URL_PATH), -9) === '/edit.php') {
	add_action('pages-sidebar','createSideMenu',array($plugin_id,ti18n_r('MENU_TRANSLATE_CURRENT_PAGE'),'page'));
	parse_str(parse_url($_SERVER['REQUEST_URI'], PHP_URL_QUERY), $qs);
	if (isset($qs['id'])) {
 		include(GSPLUGINPATH.$plugin_id.'/translate_page_form.php');
		add_action('footer', 'prepare_translate_menu', array($plugin_id, $qs['id']));
	} else {
		echo 'No page ID ...';
		echo phpinfo();
	}
}
add_action('plugins-sidebar','createSideMenu',array($plugin_id, ti18n_r('MENU_CONFIGURE_PLUGIN'),'configure'));
 
// functions
 
function ti18n($text) {
	global $plugin_id;
	i18n($plugin_id.'/'.$text);
}
 
function ti18n_r($text) {
	global $plugin_id;
	return i18n_r($plugin_id.'/'.$text);
}
 
function do_dispatch() {
	$plugin_id = $_GET['id'];
	$defaultsettingspath = GSPLUGINPATH . $plugin_id . '/assets/defaultsettings.xml';
	$datasettingspath = GSDATAOTHERPATH . $plugin_id . '_settings.xml';

	if (!file_exists($datasettingspath)) {
		  copy($defaultsettingspath, $datasettingspath);
	}

	include(GSPLUGINPATH.$plugin_id.'/utils.php');

	$conf=getXML($datasettingspath);

	if( isset( $_GET[ 'page' ] ) ) {
		if (empty($conf->authkey)) {
			include(GSPLUGINPATH.$plugin_id.'/settings.php');
		} else {
			include(GSPLUGINPATH.$plugin_id.'/translate_page.php');
		}
	}
	else if (isset($_GET['configure'])) {
		include(GSPLUGINPATH.$plugin_id.'/settings.php');
	}
	else {
		echo '<p>Translation plugin missing specific parameter.</p>';
	}
}


//console debug, use like: console_log(json_encode($data_array));

function console_log ( $msg ) {
    $msg = str_replace('"', "''", $msg);  # weak attempt to make sure there's not JS breakage
    echo '<script>var console_msg="'.$msg.'"; console.log("PHP LOG: "+console_msg);</script>';
}


?>